<?php
/**
 * phpEasyProjects - a easy Projects based activity management and todo lists
 * Copyright (C) 2005  Arthur Harder
 *
 * web: http://www.phpEasyProject.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

error_reporting(0);
define('ROOT_PATH','../');

ini_set("include_path",'../includes/' . PATH_SEPARATOR . ini_get("include_path"));
require_once('DB.php'); // PEAR DB
require('../includes/sql.class.php');
require('env_settings.class.php');
require('../includes/functions.php');
define('SMARTY_DIR',ROOT_PATH.'Smarty/libs/');
/**
 * Auf dieser Stelle wird zu PHP-Option "include_path" noch localer Pfad für
 * die lokale Unterstützung der PEAR-Library hinzugefügt
 */
require(SMARTY_DIR.'Smarty.class.php');
require('../includes/template.class.php');

$languages = orderedLanguages();
$setlang = false;

foreach ($languages as $lang)
{
    if (is_file(ROOT_PATH.'includes/lang/'.$lang.'.php'))
    {
        $setlang = true;
        include_once(ROOT_PATH.'includes/lang/'.$lang.'.php');
        break;
    }
}

if (!$setlang)
{
    include_once(ROOT_PATH.'includes/lang/en.php');
}

session_start();
ob_start();

header('Content-Type: text/html; charset=utf-8');
$template = new template();

$step = isset($_POST['step']) ? $_POST['step'] : '1';

if (isset($_POST['licenseaccept']))
{
    $_SESSION['licenseaccept'] = $_POST['licenseaccept'];
}

if (!isset($_SESSION['licenseaccept']) || $_SESSION['licenseaccept'] != 'yes')
$step = '1';

$img['i1'] = '1_.png';
$img['i2'] = '2_.png';
$img['i3'] = '3_.png';
$img['i4'] = '4_.png';
$img['i5'] = '5_.png';

switch ($step)
{
    case '2':
        $env_settings = new env_settings();
        $env_settings->setStep2();
        $template->assign('env_settings',$env_settings);
        $img['i2'] = '2.png';
    break;

    case '3':
        require_once('../includes/settings.class.php');
        $formvars = new settings();
        $formvars->getLanguages();
        $formvars->default_language = $lang;
        $formvars->webroot_path = substr($_SERVER['SCRIPT_NAME'],0,strpos($_SERVER['SCRIPT_NAME'],'/install/index.php')+1);

        if (isset($_SESSION['confmask']))
        {
            $formvars = unserialize($_SESSION['confmask']);
        }

        if (is_file(CONFIGFILE))
        {
            $formvars->getConfigData();
        }

        $template->assign('formvars',$formvars);
        $img['i3'] = '3.png';
    break;

    case '4':
        require_once('../includes/settings.class.php');
        $formvars = new settings();
        $formvars->getLanguages();
        $formvars->default_language = $lang;
        $formvars->webroot_path = substr($_SERVER['SCRIPT_NAME'],0,strpos($_SERVER['SCRIPT_NAME'],'/install/index.php')+1);

        if (isset($_POST['dbtype']))
        {
            if (!$formvars->getPostData())
            {
                $step = '3';
            }
            else
            {
                if (!$formvars->saveConfigFile())
                {
                    $step = '3';
                }
            }

            if ($step !== '3')
            {
                $env_settings = new env_settings();

                if (!$env_settings->installDB($formvars))
                {
                    $step = '3';
                    $formvars->errors = $env_settings->errors;
                }
            }

            if ($step == '4')
            {
                $formvars->successful[] = $dict['config_saved'];
                $formvars->successful[] = $dict['db_created'];
                $img['i4'] = '4.png';
            }
            else
            {
                $img['i3'] = '3.png';
            }

            if (!empty($formvars->errors))
            {
                foreach ($formvars->errors as $error)
                {
                    $errors = isset($dict[$error]) ? $dict[$error] : $error;
                }
                $template->assign('errors',$errors);
            }
            $formvars->errors = array();
            $_SESSION['confmask'] = serialize($formvars);
        }

        $template->assign('formvars',$formvars);

    break;

    case '5':
        if (!is_file('../config/config.php'))
        {
            $step = '3';
            break;
        }
        else
        {
            require_once('../config/config.php');
            require_once('../includes/employees.class.php');
        }

        $mysql = substr(phpversion(),0,1) == '5' ? 'mysql' : 'mysql';

        switch (DATABASETYPE)
        {
            case 'mysql3':
                define('DBTYPE','mysql');
            break;

            case 'mysql4':
                define('DBTYPE',$mysql);
            break;

            default:
                define('DBTYPE',$mysql);
            break;
        }
        $formvars = new employees();
        require_once('../includes/user.class.php');
        $user = new user();
        $user->empl_id = 1;

        if (!$formvars->getPostVars())
        {
            $step = '4';
        }
        else
        {
            $formvars->employees_foo->empl_status = 1;
            $formvars->employees_foo->empl_position = 100;

            $formvars->query('DELETE FROM '.DBPREFIX.'employees');
            if (!$formvars->saveRecord())
                $step = '4';
        }


        if (!empty($formvars->errors))
        {
            foreach ($formvars->errors as $error)
            {
                $errors = isset($dict[$error]) ? $dict[$error] : $error;
            }
            $template->assign('errors',$errors);
        }

        $template->assign('formvars',$formvars);
        $img['i5'] = '5.png';
    break;

    default:
        if (is_file('LICENSE.txt'))
        {
            $fp = fopen('LICENSE.txt','r');
            $license = fread($fp,filesize('LICENSE.txt'));
            fclose($fp);
        }

        if (is_file('license.txt'))
        {
            $fp = fopen('license.txt','r');
            $license = fread($fp,filesize('license.txt'));
            fclose($fp);
        }
        $template->assign('license',$license);
        $img['i1'] = '1.png';
}



$ContentTPL = '../install/step_0'.$step.'.tpl';
$PageTitle = $dict['step'].' '.$step;

if (is_file(ROOT_PATH.'build') && is_readable(ROOT_PATH.'build'))
    $build = file(ROOT_PATH.'build');

$template->assign('SiteTitle','phpEasyProject'.' - '.$dict['installation']);
$RootPath = ROOT_PATH;
$template->assign('RootPath',$RootPath);
$template->assign('PageTitle',$PageTitle);
$template->assign('ContentTPL',$ContentTPL);
$template->assign('dict',$dict);
$template->assign('img',$img);
$template->assign('version',$build[0]);
$template->assign('build',$build[1]);
$maintemplate = '../install/index.tpl';
$template->display($maintemplate);
?>